#define noid_root 4007
#define noid_blok 5113
#define noid_free 5433

typedef struct NOiD_blop
{
	unsigned long int id;		//permanent id , represent the real place in the array
	unsigned long int nfo;		//check sum id , defined higher
	unsigned long int blok;		//blok id , 	or blok count if root
	unsigned long int misc;		//other info , 	or cluster size if root
	unsigned long int last;
	unsigned long int next;
	unsigned long int back;
	unsigned long int fore;
} NOiD_blop;
//===============================================================
//===============================================================
//                    4 NOOB
//===============================================================
//===============================================================
/*
int NOiD_qty (int noid_size, int noid_cluster)
{	return (noid_size / noid_cluster) - 1;	}

int NOiD_size (int noid_qty)
{	return noid_qty * sizeof(NOiD_blop);	}

void * NOiD_cluster (int noid_numb, int noid_size,void * noid_src)
{	return noid_src + (noid_numb * noid_size);	}
*/
void * NOiD_read (int noid_numb, int noid_size, void * noid_table, void * noid_dest)
{
	while (noid_size != 0)
	{
		*(char*)(noid_dest + noid_size-1) = *(char*)(((void*)noid_table) + (noid_numb * noid_size-1));
		noid_size -= 1;
	}
	return noid_dest;
}

void * NOiD_write (int noid_numb, int noid_size, void * noid_table, void * noid_src)
{
	while (noid_size != 0)
	{
		*(char*)(((void*)noid_table) + (noid_numb * noid_size-1)) = *(char*)(noid_src + noid_size-1);
		noid_size -= 1;
	}
	return noid_src;
}
//===============================================================
//===============================================================
//                     FORMAT
//===============================================================
//===============================================================
NOiD_blop * NOiD_build (int noid_qty, int noid_cluster, void * noid_ptr)
{
	if ((noid_qty == 0)||(noid_ptr == 0)||(noid_cluster <= sizeof(NOiD_blop)))
	{	return 0;	}

	int noid_tsize = noid_qty * sizeof(NOiD_blop);
	int noid_tend = (noid_tsize + (sizeof(NOiD_blop)-1)) / noid_cluster;
	int noid_start = noid_tend + 1;
	int noid_end = noid_qty;
	int noid_go = 0;

	while (noid_go <= noid_qty)
	{
		NOiD_blop * noid_new = (NOiD_blop*)(noid_ptr + (sizeof(NOiD_blop) * noid_go));
		noid_new->id = noid_go;
		if (noid_go >= noid_start)
		{
			noid_new->nfo = noid_free;
			noid_new->blok = 1;
			noid_new->misc = 0;
			if (noid_go == noid_start)
			{	noid_new->last = noid_end;	}
			else
			{	noid_new->last = noid_go - 1;	}
			if (noid_go == noid_end)
			{	noid_new->next = noid_start;	}
			else
			{	noid_new->next = noid_go + 1;	}
			noid_new->back = 0;
			noid_new->fore = 0;
		}
		else
		{
			noid_new->nfo = noid_root;
			noid_new->blok = 1;
			noid_new->misc = noid_cluster;
			if (noid_go == 0)
			{	noid_new->last = noid_tend;	}
			else
			{	noid_new->last = noid_go - 1;	}
			if (noid_go == noid_tend)
			{	noid_new->next = 0;		}
			else
			{	noid_new->next = noid_go + 1;	}
			noid_new->back = noid_start;
			noid_new->fore = noid_start;
		}
		noid_go += 1;
	}
	return (NOiD_blop*) noid_ptr;
}
//===============================================================
//===============================================================
//                     CLUSTER
//===============================================================
//===============================================================
int NOiD_mkblok (NOiD_blop * noid_table)
/* will make a new blok completly from free cluster
   noid_table = pointer to the table in memory */
{
	if (noid_table->id != 0)
	{ 	return 999999;	}

	int noid_new_id, noid_free_id, noid_fore_id, noid_next_id;
	NOiD_blop * noid_new, * noid_free_blok, * noid_fore_blok, * noid_next_free;

	noid_free_id = noid_table->fore;	//first blok of the table
	noid_free_blok = (NOiD_blop*)(((void*)noid_table) + (noid_free_id * sizeof(NOiD_blop)));
	noid_fore_id = noid_free_blok->fore;	//second blok of the table
	noid_fore_blok = (NOiD_blop*)(((void*)noid_table) + (noid_fore_id * sizeof(NOiD_blop)));
	if (noid_free_blok->next != noid_free_blok->id)
	{
		noid_new_id = noid_free_blok->next;
	} else {
		return 999999;
	}
	noid_new = (NOiD_blop*)(((void*)noid_table) + (noid_new_id * sizeof(NOiD_blop)));
	noid_next_id = noid_new->next;
	noid_next_free = (NOiD_blop*)(((void*)noid_table) + (noid_next_id * sizeof(NOiD_blop)));

	noid_table->blok += 1;
	noid_free_blok->next = noid_new->next;
	noid_free_blok->fore = noid_new->id;
	noid_next_free->last = noid_new->last;
	noid_fore_blok->back = noid_new->id;

	noid_new->nfo = noid_blok;
	noid_new->blok = noid_table->blok;
	noid_new->misc = 0;
	noid_new->last = noid_new->id;
	noid_new->next = noid_new->id;
	noid_new->back = noid_free_blok->id;
	noid_new->fore = noid_fore_blok->id;

	return noid_new_id;
}

void NOiD_rmblok (NOiD_blop * noid_table, int noid_numb)
/* will bring back blok and all undo redo to free cluster list
   noid_table = pointer to the table in memory
   noid_numb = cluster permanent id */
{
	if ((noid_table->id != 0)||(noid_numb == 0)||(noid_numb == 1))
	{ 	return;	}

	NOiD_blop * noid_old_blok;	//the blok we have to dispose
	noid_old_blok = (NOiD_blop*)(((void*)noid_table) + (noid_numb * sizeof(NOiD_blop)));

	int noid_old_id, noid_root_id, noid_last_id, noid_fore_id, noid_back_id;
	NOiD_blop * noid_root_free, * noid_last_free, * noid_fore_blok, * noid_back_blok;

	noid_fore_id = noid_old_blok->fore;	//next allocated blok
	noid_fore_blok = (NOiD_blop*)(((void*)noid_table) + (noid_fore_id * sizeof(NOiD_blop)));
	noid_back_id = noid_old_blok->back;	//last allocated blok
	noid_back_blok = (NOiD_blop*)(((void*)noid_table) + (noid_back_id * sizeof(NOiD_blop)));
	noid_root_id = noid_table->fore;	//root of all free blok
	noid_root_free = (NOiD_blop*)(((void*)noid_table) + (noid_root_id * sizeof(NOiD_blop)));
	noid_last_id = noid_root_free->last;	//last free blok
	noid_last_free = (NOiD_blop*)(((void*)noid_table) + (noid_last_id * sizeof(NOiD_blop)));

	if ((noid_old_blok->back != noid_old_blok->id)||(noid_old_blok->fore != noid_old_blok->id))
	{
	/*
		do something about persistent data
	*/
	}

	noid_back_blok->fore = noid_old_blok->fore;
	noid_fore_blok->back = noid_old_blok->back;
	noid_old_blok->back = noid_root_free->back;
	noid_old_blok->fore = noid_root_free->fore;
	noid_old_blok->last = noid_last_free->id;
	noid_old_blok->next = noid_root_free->id;
	noid_last_free->next = noid_old_blok->id;
	noid_root_free->last = noid_old_blok->id;
	noid_old_blok->nfo = noid_free;
	noid_old_blok->blok = noid_root_free->blok;
	noid_old_blok->misc = 0;

}
//===============================================================
//===============================================================
//                ORTHOGONAL PERSISTENCE
//                  @ CLUSTER LEVEL
//===============================================================
//===============================================================
int NOiD_pushblok (NOiD_blop * noid_table, int noid_numb)
/* will push ure blok under undo list and then add new free cluster to blok
   noid_table = pointer to the table in memory
   noid_numb = cluster permanent id of the blok */
{
	if ((noid_table->id != 0)||(noid_numb == 0)||(noid_numb == 1))
	{ 	return 999999;	}

	NOiD_blop * noid_old = (NOiD_blop*)(((void*)noid_table) + (noid_numb * sizeof(NOiD_blop)));

	int noid_undo_id, noid_do_id;
	NOiD_blop * noid_undo_blok, * noid_do_blok;

	//noid_undo_id = noid_

	return 0;
}

int NOiD_popblok (NOiD_blop * noid_table, int noid_numb)
/* will pop blok to free while keeping undo redo , then 1st redo will take place
   noid_table = pointer to the table in memory
   noid_numb = cluster permanent id of the blok */
{
	if ((noid_table->id != 0)||(noid_numb == 0)||(noid_numb == 1))
	{ 	return 999999;	}

	return 0;
}


int NOiD_undoblok (NOiD_blop * noid_table, int noid_numb)
/* will rotate blok list to give next undo first access
   noid_table = pointer to the table in memory
   noid_numb = cluster permanent id of the blok */
{
	if ((noid_table->id != 0)||(noid_numb == 0)||(noid_numb == 1))
	{ 	return 999999;	}

	return 0;
}

int NOiD_redoblok (NOiD_blop * noid_table, int noid_numb)
/* will rotate blok list to give next redo first access
   noid_table = pointer to the table in memory
   noid_numb = cluster permanent id of the blok */
{
	if ((noid_table->id != 0)||(noid_numb == 0)||(noid_numb == 1))
	{ 	return 999999;	}

	return 0;
}

//=======================================================================
